﻿Imports System.Management
Public Class RegistryWatcher
    'Quelle: https://www.vb-paradise.de/index.php/Thread/129109-Registry-Key-Value-%C3%BCberwachen-WMI-Error-Nicht-analysierbare-Abfrage/?postID=1117109#post1117109
    Public Watcher As ManagementEventWatcher

    Public Sub New(ByVal hive As String, ByVal keyPath As String, ByVal Optional valueName As String = "")
        Try
            Dim query As New WqlEventQuery(
                $"Select * FROM " &
                If(valueName = "", "RegistryKeyChangeEvent", "RegistryValueChangeEvent") &
                $" WHERE Hive = '{hive}' AND KeyPath = '{keyPath.Replace("\", "\\")}'" &
                If(valueName = "", valueName, $" AND ValueName='{valueName}'"))
            Watcher = New ManagementEventWatcher(query)
            AddHandler Watcher.EventArrived, AddressOf Watcher_EventArrived
            AddHandler Watcher.Stopped, AddressOf Watcher_Stopped
        Catch managementException As ManagementException
            Console.WriteLine($"Error: {managementException.Message}")
        End Try
    End Sub

    Public Sub Start()
        Try
            Watcher.Start()
            Console.WriteLine("Waiting for an event...")
        Catch managementException As ManagementException
            Console.WriteLine($"Error: {managementException.Message}")
        End Try
    End Sub

    Public Sub [Stop]()
        Watcher.Stop()
    End Sub

    Private Sub Watcher_EventArrived(sender As Object, e As EventArrivedEventArgs)
        Console.WriteLine("Received an event.")
    End Sub

    Private Sub Watcher_Stopped(sender As Object, e As EventArgs)
        Console.WriteLine("Stopped.")
    End Sub

End Class